#include < amxmodx >
#include < orpheu >
#include < orpheu_stocks >

#define HasBit(%1,%2) ( %1 &   ( 1 << ( %2 & 31 ) ) )
#define SetBit(%1,%2) ( %1 |=  ( 1 << ( %2 & 31 ) ) )
#define DelBit(%1,%2) ( %1 &= ~( 1 << ( %2 & 31 ) ) )

#define MAX_PLAYERS 32

new g_bitCustomAirAccel;
new g_iCustomAirAccel[ MAX_PLAYERS + 1 ];
new Float:g_flCustomAirAccel[ MAX_PLAYERS + 1 ];

new OrpheuStruct:g_ppmove;

new sv_airaccelerate;

new g_iMaxPlayers;

public plugin_init( )
{
	register_plugin( "AirAccelerate", "0.0.1", "Exolent" );
	
	OrpheuRegisterHook( OrpheuGetDLLFunction( "pfnPM_Move", "PM_Move" ), "PM_Move" ); 
	OrpheuRegisterHook( OrpheuGetFunction( "PM_AirMove" ), "PM_AirMove" );
	
	sv_airaccelerate = get_cvar_pointer( "sv_airaccelerate" );
	
	g_iMaxPlayers = get_maxplayers( );
}

public client_disconnect( iPlayer )
{
	DelBit( g_bitCustomAirAccel, iPlayer );
}

public plugin_natives( )
{
	register_library( "airaccelerate" );
	
	register_native( "set_user_airaccelerate", "_set_user_airaccelerate" );
	register_native( "get_user_airaccelerate", "_get_user_airaccelerate" );
	register_native( "reset_user_airaccelerate", "_reset_user_airaccelerate" );
}

public _set_user_airaccelerate( iPlugin, iParams )
{
	if( iParams != 2 )
	{
		return 0;
	}
	
	new iPlayer = get_param( 1 );
	
	if( !( 0 <= iPlayer <= g_iMaxPlayers ) )
	{
		return 0;
	}
	
	new iNewAirAccel = get_param( 2 );
	
	if( iPlayer )
	{
		new iOldAirAccel;
		
		if( HasBit( g_bitCustomAirAccel, iPlayer ) )
		{
			iOldAirAccel = g_iCustomAirAccel[ iPlayer ];
		}
		else
		{
			SetBit( g_bitCustomAirAccel, iPlayer );
			
			iOldAirAccel = get_pcvar_num( sv_airaccelerate );
		}
		
		g_iCustomAirAccel[ iPlayer ] = iNewAirAccel;
		g_flCustomAirAccel[ iPlayer ] = float( iNewAirAccel );
		
		return iOldAirAccel;
	}
	
	for( iPlayer = 1; iPlayer <= g_iMaxPlayers; iPlayer++ )
	{
		SetBit( g_bitCustomAirAccel, iPlayer );
		
		g_iCustomAirAccel[ iPlayer ] = iNewAirAccel;
		g_flCustomAirAccel[ iPlayer ] = float( iNewAirAccel );
	}
	
	return 1;
}

public _get_user_airaccelerate( iPlugin, iParams )
{
	if( iParams != 1 )
	{
		return 0;
	}
	
	new iPlayer = get_param( 1 );
	
	if( !( 1 <= iPlayer <= g_iMaxPlayers ) )
	{
		return 0;
	}
	
	new iAirAccel;
	
	if( HasBit( g_bitCustomAirAccel, iPlayer ) )
	{
		iAirAccel = g_iCustomAirAccel[ iPlayer ];
	}
	else
	{
		iAirAccel = get_pcvar_num( sv_airaccelerate );
	}
	
	return iAirAccel;
}

public _reset_user_airaccelerate( iPlugin, iParams )
{
	if( iParams != 1 )
	{
		return 0;
	}
	
	new iPlayer = get_param( 1 );
	
	if( !( 0 <= iPlayer <= g_iMaxPlayers ) )
	{
		return 0;
	}
	
	if( iPlayer )
	{
		DelBit( g_bitCustomAirAccel, iPlayer );
	}
	else
	{
		for( iPlayer = 1; iPlayer <= g_iMaxPlayers; iPlayer++ )
		{
			DelBit( g_bitCustomAirAccel, iPlayer );
		}
	}
	
	return 1;
}

public OrpheuHookReturn:PM_Move( OrpheuStruct:ppmove, server )
{
	g_ppmove = ppmove;
	
	return OrpheuIgnored;
}

public OrpheuHookReturn:PM_AirMove( )
{
	new iPlayer = OrpheuGetStructMember( g_ppmove, "player_index" ) + 1;
	
	if( HasBit( g_bitCustomAirAccel, iPlayer )
	&&  is_user_alive( iPlayer ) )
	{
		new OrpheuStruct:movevars = OrpheuStruct:OrpheuGetStructMember( g_ppmove, "movevars" );
		OrpheuSetStructMember( movevars, "airaccelerate", g_flCustomAirAccel[ iPlayer ] );
	}
	
	return OrpheuIgnored;
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang11274\\ f0\\ fs16 \n\\ par }
*/
